/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public class Polygon {
    Vertex v1, v2, v3;
    Texture texture;
    public Polygon(Vertex vv1, Vertex vv2, Vertex vv3, Texture tex) {
        v1 = vv1;
        v2 = vv2;
        v3 = vv3;
        texture = tex;
    } 
    
    
    
    public void paintTexture(RGB display) throws Exception {
    //----------------------------
    //|          A               |
    //|        ****              |
    //|  dx12*******             |
    //|    **********            |
    //|  B************dx13       |
    //|     ***********          |
    //|    dx23*********         |
    //|-----------@@@@@@@--------|
    //|              *****       |
    //|                 ***      |
    //|                    C     |
    //----------------------------
        
        Vertex a = v1;
        Vertex b = v2;
        Vertex c = v3;
        Vertex t; //temp
        
        
        //сортируем вершины, чтобы они были по порядку
        if(b.sy < a.sy) { //если b выше чем a
            t = a;
	    a = b;
	    b = t;
        }
        if(c.sy < a.sy) { //если c выше чем a
            t = c;
	    c = a;
	    a = t;
        }
        if (b.sy > c.sy) { //если b ниже чем c
	    t = b;
	    b = c;
	    c = t;
	}
        if(a.sy == c.sy) return;
        if(a.sy > display.h) return;
        if(c.sy < 0) return;
        
        final int fp = 16;
        
        final int[][] tex = texture.tex;
        final int[] rgb = display.rgb;
        final int rgbW = display.w;
        final int rgbH = display.h;
        
        
        int pixel_start, pixel_end, length, x, u, v, tempI;
        int dx13 = 0, dx12 = 0, dx23 = 0; //
        int du13 = 0, du12 = 0, du23 = 0; // приращения
        int dv13 = 0, dv12 = 0, dv23 = 0; //
        
        if(c.sy != a.sy) {
            tempI = c.sy - a.sy;
            dx13 = (c.sx - a.sx)<<fp;
            dx13 /= tempI;
            
            du13 = (c.u - a.u)<<fp;
            du13 /= tempI;
            
            dv13 = (c.v - a.v)<<fp;
            dv13 /= tempI;
	}
        if(b.sy != a.sy) {
            tempI = b.sy - a.sy;
            dx12 = (b.sx - a.sx)<<fp;
            dx12 /= tempI;
            
            du12 = (b.u - a.u)<<fp;
            du12 /= tempI;
            
            dv12 = (b.v - a.v)<<fp;
            dv12 /= tempI;
	}
        if(c.sy != b.sy) {
            tempI = c.sy - b.sy;
            dx23 = (c.sx - b.sx)<<fp;
            dx23 /= tempI;
            
            du23 = (c.u - b.u)<<fp;
            du23 /= tempI;
            
            dv23 = (c.v - b.v)<<fp;
            dv23 /= tempI;
	}
        
        
        int x_start = a.sx + ((b.sy - a.sy) * dx13>>fp); //начало линии
        int x_end = b.sx; //конец линии
        if(x_start == x_end) return;
        
        
        
        int u_start = (a.u<<fp) + (b.sy - a.sy) * du13;
        int u_end = b.u<<fp;
        
        int v_start = (a.v<<fp) + (b.sy - a.sy) * dv13;
        int v_end = b.v<<fp;
        
        
        tempI = x_start-x_end;
        final int du = (u_start-u_end)/tempI;
        final int dv = (v_start-v_end)/tempI;
        
        
        
        x_start = a.sx<<fp;
        u_start = a.u<<fp;
        v_start = a.v<<fp;
        
        x_end = a.sx<<fp;
        u_end = a.u<<fp;
        v_end = a.v<<fp;
        
        int y_start = a.sy;
        int y_end = c.sy;
        if(y_end > rgbH) y_end = rgbH;
        
        
        for(;y_start<y_end; y_start++) { //рисуем все горизонтальные линии
            //находим начало и конец отрезка
            x_start += dx13;
            u_start += du13;
            v_start += dv13;
            
            if(y_start < b.sy) {
                x_end += dx12;
                u_end += du12;
                v_end += dv12;
            }
            if(y_start == b.sy) {
                x_end = b.sx<<fp;
                u_end = b.u<<fp;
                v_end = b.v<<fp;
            }
            if(y_start > b.sy) {
                x_end += dx23;
                u_end += du23;
                v_end += dv23;
            }
            if(y_start<0) continue; //перейти в начало цикла
            
            
            if(x_start > x_end) { //если надо меняем начало и конец отрезка
                x = x_end>>fp;
                u = u_end;
                v = v_end;
                length = (x_start-x_end)>>fp;
            } else {
                x = x_start>>fp;
                u = u_start;
                v = v_start;
                length = (x_end-x_start)>>fp;
            }
            
            
            
            
            if(x < 0) {
                length += x;
                u += du*-x;
                v += dv*-x;
                x = 0;
            }
            if(x+length > rgbW) length = rgbW-x;
            
            
            pixel_start = rgbW * y_start + x; //куда рисовать в массиве
            pixel_end = pixel_start + length; //до куда рисовать в массив
            //try {
                for(;pixel_start<pixel_end; pixel_start++) {
                    rgb[pixel_start] = tex[u>>fp][v>>fp];
                    u += du;
                    v += dv;
                }
            //} catch (Exception e) {System.err.println("ERROR  u"+(u>>fp)+"  v"+(v>>fp)+" "+e);}
        }
        
    }
    
    
    
    
    
    
    
    
}
        
        
        
        
        
        

    
    
    
    
    
